""" Code is generated by ucloud-model, DO NOT EDIT IT. """

from ucloud.core.typesystem import schema, fields


class ImageInfoSchema(schema.ResponseSchema):
    """ImageInfo - UK8S 可用镜像信息"""

    fields = {
        "ImageId": fields.Str(required=True, load_from="ImageId"),
        "ImageName": fields.Str(required=True, load_from="ImageName"),
        "NotSupportGPU": fields.Bool(required=True, load_from="NotSupportGPU"),
        "ZoneId": fields.Int(required=True, load_from="ZoneId"),
    }


class K8SNodeConditionSchema(schema.ResponseSchema):
    """K8SNodeCondition - Kubernetes Node Condition"""

    fields = {
        "LastProbeTime": fields.Str(required=False, load_from="LastProbeTime"),
        "LastTransitionTime": fields.Str(
            required=False, load_from="LastTransitionTime"
        ),
        "Message": fields.Str(required=False, load_from="Message"),
        "Reason": fields.Str(required=False, load_from="Reason"),
        "Status": fields.Str(required=False, load_from="Status"),
        "Type": fields.Str(required=False, load_from="Type"),
    }


class UHostIPSetSchema(schema.ResponseSchema):
    """UHostIPSet - 云主机IP信息"""

    fields = {
        "Bandwidth": fields.Int(required=False, load_from="Bandwidth"),
        "Default": fields.Str(
            required=False, load_from="Default"
        ),  # Deprecated, will be removed at 1.0
        "IP": fields.Str(required=False, load_from="IP"),
        "IPId": fields.Str(required=False, load_from="IPId"),
        "Mac": fields.Str(required=False, load_from="Mac"),
        "SubnetId": fields.Str(required=False, load_from="SubnetId"),
        "Type": fields.Str(required=False, load_from="Type"),
        "VPCId": fields.Str(required=False, load_from="VPCId"),
    }


class KubeProxySchema(schema.ResponseSchema):
    """KubeProxy - KubeProxy信息"""

    fields = {
        "Mode": fields.Str(required=False, load_from="Mode"),
    }


class NodeInfoV2Schema(schema.ResponseSchema):
    """NodeInfoV2 - UK8S 节点信息"""

    fields = {
        "AsgId": fields.Str(required=True, load_from="AsgId"),
        "CPU": fields.Int(required=True, load_from="CPU"),
        "CreateTime": fields.Int(required=True, load_from="CreateTime"),
        "ExpireTime": fields.Int(required=True, load_from="ExpireTime"),
        "GPU": fields.Int(required=False, load_from="GPU"),
        "IPSet": fields.List(UHostIPSetSchema()),
        "InstanceId": fields.Str(required=True, load_from="InstanceId"),
        "InstanceName": fields.Str(required=True, load_from="InstanceName"),
        "InstanceType": fields.Str(required=True, load_from="InstanceType"),
        "KubeProxy": KubeProxySchema(),
        "MachineType": fields.Str(required=True, load_from="MachineType"),
        "Memory": fields.Int(required=True, load_from="Memory"),
        "NodeId": fields.Str(required=True, load_from="NodeId"),
        "NodeLogInfo": fields.Str(required=True, load_from="NodeLogInfo"),
        "NodeRole": fields.Str(required=True, load_from="NodeRole"),
        "NodeStatus": fields.Str(required=True, load_from="NodeStatus"),
        "OsName": fields.Str(required=True, load_from="OsName"),
        "OsType": fields.Str(required=True, load_from="OsType"),
        "Unschedulable": fields.Bool(required=True, load_from="Unschedulable"),
        "Zone": fields.Str(required=True, load_from="Zone"),
    }


class ClusterSetSchema(schema.ResponseSchema):
    """ClusterSet - 集群信息"""

    fields = {
        "ApiServer": fields.Str(required=True, load_from="ApiServer"),
        "ClusterId": fields.Str(required=True, load_from="ClusterId"),
        "ClusterLogInfo": fields.Str(
            required=False, load_from="ClusterLogInfo"
        ),
        "ClusterName": fields.Str(required=True, load_from="ClusterName"),
        "CreateTime": fields.Int(required=False, load_from="CreateTime"),
        "ExternalApiServer": fields.Str(
            required=False, load_from="ExternalApiServer"
        ),
        "K8sVersion": fields.Str(required=True, load_from="K8sVersion"),
        "MasterCount": fields.Int(required=True, load_from="MasterCount"),
        "NodeCount": fields.Int(required=False, load_from="NodeCount"),
        "PodCIDR": fields.Str(required=True, load_from="PodCIDR"),
        "ServiceCIDR": fields.Str(required=True, load_from="ServiceCIDR"),
        "Status": fields.Str(required=False, load_from="Status"),
        "SubnetId": fields.Str(required=True, load_from="SubnetId"),
        "VPCId": fields.Str(required=True, load_from="VPCId"),
    }
